var URL = "http://zmmt.rtb1688.com";
(function($, owner) {
	owner.createState = function(name, uid, callback) {
		var state = owner.getState();
		state.username = name;
		state.uid = uid;
		state.token = "token123456789";
		owner.setState(state);
		return callback();
	};

	/**
	 * 获取当前状态
	 **/
	owner.getState = function() {
		var stateText = localStorage.getItem('$state') || "{}";
		return JSON.parse(stateText);
	};

	/**
	 * 设置当前状态
	 **/
	owner.setState = function(state) {
		state = state || {};
		localStorage.setItem('$state', JSON.stringify(state));
		//var settings = owner.getSettings();
		//settings.gestures = '';
		//owner.setSettings(settings);
	};
	/**
	 * 设置应用本地配置
	 **/
	owner.setSettings = function(settings) {
		var data = owner.getSettings();
		if(arguments.length > 1){
			data[arguments[1]] = settings;
		} else {
			data = settings || {};
		}
		localStorage.setItem('$settings', JSON.stringify(data));
	}

	/**
	 * 获取应用本地配置
	 **/
	owner.getSettings = function() {
		var settingsText = localStorage.getItem('$settings') || "{}";
		var data = JSON.parse(settingsText);
		return arguments.length > 0 ? data[arguments[0]] : data;
	}
	
	owner.getSession = function(){
		return owner.getSettings('session') || {};
	};
	
	//判断是否是ios
	owner.ios = function() {
		if (plus && plus.os.name.toLocaleLowerCase() == 'ios') {
			return true;
		} else {
			return false;
		}
	};
	
	//IOS判断QQ是否已经安装
	owner.isQQInstalled = function() {
		if (mui.os.ios) {
			var TencentOAuth = plus.ios.import("TencentOAuth");
			var isQQInstalled = TencentOAuth.iphoneQQInstalled();
			return isQQInstalled == '0' ? false : true;
		}
		return true;
	};
	//IOS判断微信是否已经安装
	owner.isWXInstalled = function() {
		if (mui.os.ios) {
			var a = plus.ios.import("WXApi");
			return a.isWXAppInstalled()
		}
		return true
	};
	owner.trim = function(str) {　　
		return str.replace(/(^\s*)|(\s*$)/g, "");　　
	};
	
	owner.isLogin = function(){
		var userState = JSON.parse(localStorage.getItem('$state') || "{}");
		if (userState.uid && userState.uid != '') {
			return true;
		} else {
			return false;
		}
	};
	/**
	 * 重写退出app
	 */
	owner.quitApp = function() {
		$.oldBack = mui.back;
		var backButtonPress = 0;
		$.back = function(event) {
			backButtonPress++;
			if (backButtonPress > 1) {
				plus.runtime.quit();
			} else {
				plus.nativeUI.toast('再按一次退出醉美茅台');
			}
			setTimeout(function() {
				backButtonPress = 0;
			}, 1000);
			return false;
		};
	};
	owner.getEcshopData = function(b) {
		if (!b.succeed) {
			return {
				data: {},
				status: {
					succeed: 0,
					error_desc: b.error_desc
				}
			}
		}
		if (b.retval && b.retval.status && b.retval.status.error_code == 100) {
			app.logout(function(){
				showLogin();
			});
		}
		return b.retval
	};
	owner.sendRequest = function(url, data, callback) {
		var b = data.config || {};
		if (typeof data.config != "undefined") {
			delete data.config
		}
		var d = {
			type: "POST",
			silence: false,
			error_show: true
		};
		for (var f in d) {
			if (b[f] != undefined) {
				d[f] = b[f]
			}
		}
		var g = {};
		var c = typeof window.plus != "undefined" ? plus.webview.currentWebview() : {};
		var is_out = url.indexOf("http://") != -1 || url.indexOf("https://") != -1;
		$.ajax({
			url: is_out ? url : URL + '/ECMobile/?url=' + url,
			data: data,
			type: d.type,
			dataType: "json",
			timeout: 10000,
			beforeSend: function() {
				if (typeof window.plus == "object") {
					console.log(c.id + ":" + d.type + " " + url + " start");
				}
				if (!d.silence && typeof window.plus == "object") {
					plus.nativeUI.showWaiting("数据加载中，请稍后...", {
						modal: false
					})
				}
			},
			error: function(k, l, j) {
				if (!d.silence && typeof window.plus == "object") {
					plus.nativeUI.closeWaiting()
				}
				if(typeof window.plus == "object"){
					console.log(c.id + ":" + l + " " + url + " failed, error: " + l + ", " + j + ", " + k.responseText);
				}
				if (d.error_show) {
					if (l == "abort") {
						l = "网络连接失败"
					} else {
						if (l == "timeout") {
							l = "网络连接超时"
						}
					}
					if (j == null) {
						j = ""
					}
				}
				g = {
					success: 0,
					error_desc: l + (j ? +", " + j : "")
				};
				callback(owner.getEcshopData(g))
			},
			success: function(j, l, k) {
				if (!d.silence && typeof window.plus == "object") {
					plus.nativeUI.closeWaiting()
				}
				if(typeof window.plus == "object"){
					console.log(c.id + ":" + l + " " + url + " end");
				}
				g.succeed = 1;
				g.retval = j;
				callback(owner.getEcshopData(g))
			}
		})
	};
	/**
	 * 通用超链接处理函数
	 * @param {Object} obj 默认为document
	 * @param {Object} fun hash处理函数
	 */
	owner.makeLink = function(obj, fun){
		var doc = obj || document;
		$(doc).on("tap", "a", function(p) {
			var h = this.getAttribute("href") || "";
			var n = this.getAttribute("data-extras");
			n = typeof n == "undefined" ? {} : JSON.parse(n);
			var o = (typeof this.getAttribute("data-frame") != "undefined" && this.getAttribute("data-frame") == 1);
			if (h.length == 0 || h == '#') {
				return false
			}
			if(this.hash){
				return fun ? fun(this.hash.replace('#', '')) : false;
			}
			if (o) {
				console.log("open frame url: " + h);
				showPage('frame.html', '', {page_title: n.title,page_url: h});
			} else {
				var open_type = '';
				if(h == 'goods.html' || h == 'article.html'){
					open_type = 'nocache';
				} else if(h == 'cart.html' || h == 'my.html'){
					open_type = 'refresh';
				}
				showPage(h, open_type, n);
			}
		});
	};
	/**
	 * 用户登录
	 **/
	owner.login = function(loginInfo, callback) {
		callback = callback || $.noop;
		loginInfo = loginInfo || {};
		loginInfo.username = loginInfo.username || '';
		loginInfo.password = loginInfo.password || '';
		if (!app.isPhone(loginInfo.username)) {
			return callback('手机号码格式不正确');
		}
		if (loginInfo.password.length < 6) {
			return callback('密码最短为 6 个字符');
		}
		owner.sendRequest('/user/signin',{
			name: loginInfo.username,
			password: loginInfo.password
		}, function(result){
			if(result.status.succeed){
				owner.setSettings(result.data.session, 'session');
				owner.setSettings(result.data.user, 'user');
				return owner.createState(loginInfo.username, result.data.session.uid, callback);
			}else{
				callback(result.status.error_desc || '用户名或密码错误');
			}
		});
	};
	/**
	 * 新用户注册
	 **/
	owner.reg = function(regInfo, callback) {
		callback = callback || $.noop;
		regInfo = regInfo || {};
		regInfo.username = regInfo.username || '';
		regInfo.password = regInfo.password || '';
		regInfo.invite = regInfo.invite || '';
		regInfo.captcha = regInfo.captcha || '';
		regInfo.email = regInfo.email || regInfo.username + '@139.com';
		if (!app.isPhone(regInfo.username)) {
			return callback('手机号码格式不正确');
		}
		if (regInfo.password.length < 6) {
			return callback('密码最短需要 6 个字符');
		}
		if(regInfo.captcha.length < 4){
			return callback('请输入四位验证码');
		}
		owner.sendRequest(URL+'/user/signup',regInfo, function(result){
			if(result.status.succeed){
				owner.setSettings(result.data.session, 'session');
				owner.setSettings(result.data.user, 'user');
				return owner.createState(regInfo.username, result.data.session.uid, callback);
			}else{
				return callback(result.status.error_desc || '用户名已被注册');
			}
		});
	};
	owner.logout = function(c) {
		owner.sendRequest("/user/logout", {}, function(a) {
			if (!a.status.succeed) {
				mui.alert(a.status.error_desc);
				return
			}
			owner.setState({});
			owner.setSettings({}, 'session');
			owner.setSettings({}, 'user');
			var b = plus.webview.getWebviewById("cart.html");
			mui.fire(b, "refresh", {
				action: "logout"
			});
			if (c) {
				c()
			}
		});
	};
	owner.copyToClip = function(content) {
		if (mui.os.android) {
			var c = plus.android.importClass("android.content.Context");
			var a = plus.android.runtimeMainActivity();
			var d = a.getSystemService(c.CLIPBOARD_SERVICE);
			plus.android.invoke(d, "setText", content);
			console.log("复制到剪贴板：" + content)
		} else {
			if (mui.os.ios) {
				var b = plus.ios.importClass("UIPasteboard");
				var f = b.generalPasteboard();
				f.setValueforPasteboardType(content, "public.utf8-plain-text");
				console.log("复制到剪贴板：" + content)
			}
		}
	};
	owner.getShortUrl = function(a, c) {
		var b = "http://api.t.sina.com.cn/short_url/shorten.json?source=3213676317&url_long=";
		owner.sendRequest(b + escape(a), {
			config: {
				type: "GET"
			}
		}, function(d) {
			c(d)
		})
	};
	owner.loadImg = function(e, d) {
		var c = "_downloads/image/" + md5(e) + ".jpg";
		var a = plus.io.convertLocalFileSystemURL(c);
		var b = new Image();
		b.src = a;
		b.onload = function() {
			console.log("已存在==" + c);
			d(mui.os.ios ? c : a)
		};
		b.onerror = function() {
			console.log("不存在==" + c);
			var f = plus.downloader.createDownload(e, {
				filename: c,
				timeout: 10,
				retry: 2
			}, function(h, g) {
				console.log("下载回调status==" + g + "-->" + c);
				if (g == 200) {
					d(mui.os.ios ? c : a)
				} else {
					delFile(c);
					h.abort()
				}
			});
			f.start()
		}
	};
	/**
	 * 是否为手机号码
	 */
	owner.isPhone = function(mobile){
		var phone = /^1([38]\d|4[57]|5[0-35-9]|7[06-8]|8[89])\d{8}$/;
		return phone.test(mobile);
	};
	/**
	 * 删除文件
	 * @param {String} a
	 */
	owner.delFile = function(a) {
		plus.io.resolveLocalFileSystemURL(a, function(b) {
			b.remove(function(c) {
				console.log("文件删除成功==" + a)
			}, function(c) {
				console.log("文件删除失败=" + a)
			})
		})
	};
	
	/**
	 * 打开软键盘
	 */
	$.openSoftKeyboard = function() {
		if (mui.os.ios) {
			var webView = plus.webview.currentWebview().nativeInstanceObject();
			webView.plusCallMethod({
				"setKeyboardDisplayRequiresUserAction": false
			});
		} else {
			var webview = plus.android.currentWebview();
			plus.android.importClass(webview);
			webview.requestFocus();
			var Context = plus.android.importClass("android.content.Context");
			var InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");
			var main = plus.android.runtimeMainActivity();
			var imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);
			imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);
		}
	};
})(mui, window.app={});

function reloadWvLoad(){
	var errorText = document.createElement('div');
    errorText.innerHTML = '<h4>网络不给力，请检查网络！</h4><button id="reloadWv" class="mui-btn mui-btn-negative">重新加载</button>';
    errorText.setAttribute('class','empty-show');
    document.body.appendChild(errorText);
	
}
/**
 * 通用openWindow
 * @param {String} url
 * @param {String} type 类型（普通、nocache-禁止缓存页面、refresh-打开前刷新）
 * @param {Object} param 参数
 * @param {Object} aniShow 显示样式
 * @param {Function} func 回调函数
 */
function showPage(url, type, param, aniShow, func){
	var showType = type || '';
	var wv = plus.webview.getWebviewById(url);
	aniShow = aniShow || 'pop-in';
	if(type == 'nocache'){
		var detailPage=plus.webview.getWebviewById(url);
		if(detailPage!=null){
			detailPage.hide();
			detailPage.close();
		}
	} else if(type == 'refresh' && wv){
		mui.fire(wv, "refresh");
		wv.show();
		return ;
	}
	setTimeout(function(){
		var wv = mui.openWindow({
			id: url,
			url: url,
			extras: param,
			show: {
				autoShow:true,
				aniShow: 'pop-in'
			},
			waiting: {
				autoShow: false
			}
		});
		if(func) { func(wv); };
	},100)
}
function showProduct(eid){
	showPage('goods.html', 'nocache', {eid:eid});
}
function showLogin(tip){
	if(tip){
		mui.toast('您尚未登陆');
	}
	var wv = plus.webview.getLaunchWebview();
	mui.fire(wv, 'login', {backurl: self.id});
	wv.show();
}
function toCart(){
	showPage('cart.html', 'refresh');
}
/**
 * 在frame中打开外部链接
 * @param {String} title 标题
 * @param {String} url 链接
 * @param {Object} param 参数
 */
function showFrame(title, url, param){
	var data = {page_title: title, page_url: url};
	if(typeof param == "object"){
		for(var k in param) {
			data[k] = param[k];
		}
	}
	mui.openWindow({
		id: 'frame.html',
		url: 'frame.html',
		extras: data,
		show: {
			autoShow: true,
			aniShow: 'pop-in'
		},
		waiting: {
			autoShow: false
		}
	});
}

mui('body').on('tap', '#closeWv', function() {
	if(plus.webview.currentWebview().parent()!=null)
		plus.webview.currentWebview().parent().close();
	else
		plus.webview.currentWebview().close();
});

mui('body').on('tap', '#reloadWv', function() {
	plus.webview.currentWebview().reload();
});